import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JFrame;

public class GUIeinfach extends JFrame {

	Algorithmus algorithmus;
	Graphics2D graphics;

	public GUIeinfach() {
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setTitle("Dijkstra-Algorithmus");
		this.initialisiere();
	}

	public void initialisiere() {
		algorithmus = new Algorithmus();
		this.setVisible(true);
		this.setSize(634, 769);
		this.graphics = (Graphics2D) this.getContentPane().getGraphics();
		Image img = Toolkit.getDefaultToolkit().getImage("Lageplan.gif");
		MediaTracker mediaTracker = new MediaTracker(this);
		mediaTracker.addImage(img, 0);
		try {
			mediaTracker.waitForID(0);
		} catch (InterruptedException ie) {
			System.err.println(ie);
			System.exit(1);
		}
		graphics.drawImage(img, 0, 0, null);
	}

	public void zeichneKnoten(Knoten k, Color farbe) {
		graphics.setColor(farbe);
		graphics.fillOval(k.x - 18, k.y - 18, 37, 37);
		graphics.setColor(Color.black);
		graphics.setStroke(new BasicStroke(2));
		graphics.drawOval(k.x - 18, k.y - 18, 37, 37);
		graphics.setFont(new Font("Helvetica", Font.PLAIN, 24));
		graphics.drawString(k.name, k.x - 7, k.y + 9);
	}

	public void zeichneWeg(Knoten knoten, Color farbe) {
		zeichneKnoten(knoten, farbe);
		if (knoten.vorgaengerImPfad != null) {
			zeichneWeg(knoten.vorgaengerImPfad, farbe);
		}
	}

	public static void main(String[] argv) {
		GUIeinfach ui = new GUIeinfach();
		ui.initialisiere();
		Algorithmus algo = ui.algorithmus;
		algo.startknoten = algo.graph[9];
		algo.zielknoten = algo.graph[14];
		algo.berechneWeg();
		ui.zeichneWeg(algo.zielknoten, Color.blue);
	}
}